;; Clean+/theme.jl

;; Copyright (C) 2000 Jess Gonzlez <jgonzlz@terra.es>
;; Based on "Clean" theme by Dwight Engen <dengen40@yahoo.com>


;; This theme is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; It is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawmill; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(require 'gradient)

(defgroup
	Clean+
	"Clean+"
	:group appearance
)
  
(defcustom
	Clean+:ShowIcon t
	"Show window icon on titlebar"
	:user-level novice
	:type boolean
	:group (appearance Clean+)
)
	
(defcustom
	Clean+:TitleFont default-font
	"Titlebar font: \\w"
	:user-level intermediate
	:type font
	:group (appearance Clean+)
)
	
(defcustom
	Clean+:DefaultTitleText (get-color "white")
	"Default Titlebar text color: \\w"
	:user-level intermediate
	:type color
	:group (appearance Clean+)
)
	
(defcustom
	Clean+:DefaultTitleLeft (get-color "grey64")
	"Default Titlebar left color: \\w"
	:user-level intermediate
	:type color
	:group (appearance Clean+)
)
	
(defcustom
	Clean+:DefaultTitleRight (get-color "black")
	"Default Titlebar right color: \\w"
	:user-level intermediate
	:type color
	:group (appearance Clean+)
)

(defcustom
	Clean+:FocusedTitleText (get-color "white")
	"Focused Titlebar text color: \\w"
	:user-level intermediate
	:type color
	:group (appearance Clean+)
)
	
(defcustom
	Clean+:FocusedTitleLeft (get-color "SteelBlue4")
	"Focused Titlebar left color: \\w"
	:user-level intermediate
	:type color
	:group (appearance Clean+)
)
	
(defcustom
	Clean+:FocusedTitleRight (get-color "SteelBlue3")
	"Focused Titlebar right color: \\w"
	:user-level intermediate
	:type color
	:group (appearance Clean+)
)

(defcustom
	Clean+:DecorationHighlight (get-color "white")
	"Decoration Highlight color: \\w"
	:user-level expert
	:type color
	:group (appearance Clean+)
)

(defcustom
	Clean+:DecorationFlat (get-color "grey77")
	"Decoration Flat color: \\w"
	:user-level expert
	:type color
	:group (appearance Clean+)
)

(defcustom
	Clean+:DecorationShadow (get-color "black")
	"Decoration Shadow color: \\w"
	:user-level expert
	:type color
	:group (appearance Clean+)
)

(defcustom
	Clean+:EnabledButton (get-color "black")
	"Enabled Button color: \\w"
	:user-level expert
	:type color
	:group (appearance Clean+)
)

(defcustom
	Clean+:DisabledButton (get-color "grey50")
	"Disabled Button color: \\w"
	:user-level expert
	:type color
	:group (appearance Clean+)
)

(defcustom
	Clean+:DefaultIcon ()
	"Default Icon image: \\w"
	:user-level expert
	:type file-name
	:group (appearance Clean+)
)

(let*
	(
		sdw hlt flt dbt ebt ftr
     
		(default-icon (make-image "icon.png"))
		
		(user-icon ())
		
		(menu-image
			(lambda (w)
				(let
					((icon (window-icon-image w)))
					(if icon
						icon
						(if user-icon
							user-icon
							default-icon
						)
					)
				)
			)
		)
		
		(minimize-image-default (make-sized-image 13 13))
		(minimize-image-default-mask [
			[hlt hlt hlt hlt hlt hlt hlt hlt hlt hlt hlt hlt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt flt flt flt ebt ebt ebt ebt ebt flt flt flt sdw]
			[hlt flt flt flt flt ebt ebt ebt flt flt flt flt sdw]
			[hlt flt flt flt flt flt ebt flt flt flt flt flt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt sdw sdw sdw sdw sdw sdw sdw sdw sdw sdw sdw sdw]
		])
		
		(minimize-image-disabled (make-sized-image 13 13))
		(minimize-image-disabled-mask [
			[hlt hlt hlt hlt hlt hlt hlt hlt hlt hlt hlt hlt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt flt flt flt dbt dbt dbt dbt dbt flt flt flt sdw]
			[hlt flt flt flt flt dbt dbt dbt flt flt flt flt sdw]
			[hlt flt flt flt flt flt dbt flt flt flt flt flt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt sdw sdw sdw sdw sdw sdw sdw sdw sdw sdw sdw sdw]
		])
		
		(minimize-image-clicked (make-sized-image 13 13))
		(minimize-image-clicked-mask [
			[ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr]
			[ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr]
			[ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr]
			[ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr]
			[ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr]
			[ftr ftr ftr ftr ebt ebt ebt ebt ebt ftr ftr ftr ftr]
			[ftr ftr ftr ftr ftr ebt ebt ebt ftr ftr ftr ftr ftr]
			[ftr ftr ftr ftr ftr ftr ebt ftr ftr ftr ftr ftr ftr]
			[ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr]
			[ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr]
			[ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr]
			[ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr]
			[ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr]
		])
		
		(minimize-image `(
			,minimize-image-default
			()
			()
			,minimize-image-clicked
		))
		
		(maximize-image-default (make-sized-image 13 13))
		(maximize-image-default-mask [
			[hlt hlt hlt hlt hlt hlt hlt hlt hlt hlt hlt hlt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt flt flt flt flt flt ebt flt flt flt flt flt sdw]
			[hlt flt flt flt flt ebt ebt ebt flt flt flt flt sdw]
			[hlt flt flt flt ebt ebt ebt ebt ebt flt flt flt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt sdw sdw sdw sdw sdw sdw sdw sdw sdw sdw sdw sdw]
		])
		
		(maximize-image-disabled (make-sized-image 13 13))
		(maximize-image-disabled-mask [
			[hlt hlt hlt hlt hlt hlt hlt hlt hlt hlt hlt hlt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt flt flt flt flt flt dbt flt flt flt flt flt sdw]
			[hlt flt flt flt flt dbt dbt dbt flt flt flt flt sdw]
			[hlt flt flt flt dbt dbt dbt dbt dbt flt flt flt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt sdw sdw sdw sdw sdw sdw sdw sdw sdw sdw sdw sdw]
		])
		
		(maximize-image-clicked (make-sized-image 13 13))
		(maximize-image-clicked-mask [
			[ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr]
			[ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr]
			[ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr]
			[ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr]
			[ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr]
			[ftr ftr ftr ftr ftr ftr ebt ftr ftr ftr ftr ftr ftr]
			[ftr ftr ftr ftr ftr ebt ebt ebt ftr ftr ftr ftr ftr]
			[ftr ftr ftr ftr ebt ebt ebt ebt ebt ftr ftr ftr ftr]
			[ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr]
			[ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr]
			[ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr]
			[ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr]
			[ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr]
		])
		
		(maximize-image `(
			,maximize-image-default
			()
			()
			,maximize-image-clicked
		))
		
		(close-image-default (make-sized-image 13 13))
		(close-image-default-mask [
			[hlt hlt hlt hlt hlt hlt hlt hlt hlt hlt hlt hlt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt flt flt flt ebt flt flt flt ebt flt flt flt sdw]
			[hlt flt flt ebt ebt ebt flt ebt ebt ebt flt flt sdw]
			[hlt flt flt flt ebt ebt ebt ebt ebt flt flt flt sdw]
			[hlt flt flt flt flt ebt ebt ebt flt flt flt flt sdw]
			[hlt flt flt flt ebt ebt ebt ebt ebt flt flt flt sdw]
			[hlt flt flt ebt ebt ebt flt ebt ebt ebt flt flt sdw]
			[hlt flt flt flt ebt flt flt flt ebt flt flt flt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt sdw sdw sdw sdw sdw sdw sdw sdw sdw sdw sdw sdw]
		])
		
		(close-image-disabled (make-sized-image 13 13))
		(close-image-disabled-mask [
			[hlt hlt hlt hlt hlt hlt hlt hlt hlt hlt hlt hlt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt flt flt flt dbt flt flt flt dbt flt flt flt sdw]
			[hlt flt flt dbt dbt dbt flt dbt dbt dbt flt flt sdw]
			[hlt flt flt flt dbt dbt dbt dbt dbt flt flt flt sdw]
			[hlt flt flt flt flt dbt dbt dbt flt flt flt flt sdw]
			[hlt flt flt flt dbt dbt dbt dbt dbt flt flt flt sdw]
			[hlt flt flt dbt dbt dbt flt dbt dbt dbt flt flt sdw]
			[hlt flt flt flt dbt flt flt flt dbt flt flt flt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt flt flt flt flt flt flt flt flt flt flt flt sdw]
			[hlt sdw sdw sdw sdw sdw sdw sdw sdw sdw sdw sdw sdw]
		])
		
		(close-image-clicked (make-sized-image 13 13))
		(close-image-clicked-mask [
			[ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr]
			[ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr]
			[ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr]			
			[ftr ftr ftr ftr ebt ftr ftr ftr ebt ftr ftr ftr ftr]
			[ftr ftr ftr ebt ebt ebt ftr ebt ebt ebt ftr ftr ftr]
			[ftr ftr ftr ftr ebt ebt ebt ebt ebt ftr ftr ftr ftr]
			[ftr ftr ftr ftr ftr ebt ebt ebt ftr ftr ftr ftr ftr]
			[ftr ftr ftr ftr ebt ebt ebt ebt ebt ftr ftr ftr ftr]
			[ftr ftr ftr ebt ebt ebt ftr ebt ebt ebt ftr ftr ftr]
			[ftr ftr ftr ftr ebt ftr ftr ftr ebt ftr ftr ftr ftr]
			[ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr]
			[ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr]
			[ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr ftr]
		])
		
		(close-image `(
			,close-image-default
			,nil
			,nil
			,close-image-clicked
		))

		(side-top (make-sized-image 1 4))
		(side-top-mask [
			[hlt]
			[flt]
			[flt]
			[sdw]
		])
		
		(side-bottom (make-sized-image 1 3))
		(side-bottom-mask [
			[flt]
			[flt]
			[sdw]
		])
		
		(side-subtitle (make-sized-image 1 3))
		(side-subtitle-mask [
			[hlt]
			[flt]
			[flt]
		])
		
		(side-left (make-sized-image 3 1))
		(side-left-mask [
			[hlt flt flt]
		])

		(corner-top-sides (make-sized-image 4 1))
		(corner-top-sides-mask [
			[hlt flt flt sdw]
		])

		(side-right (make-sized-image 3 1))
		(side-right-mask [
			[flt flt sdw]
		])

		(corner-top-left (make-sized-image 10 10))
		(corner-top-left-mask [
			[hlt hlt hlt hlt hlt hlt hlt hlt hlt hlt]
			[hlt flt flt flt flt flt flt flt flt flt]
			[hlt flt flt flt flt flt flt flt flt flt]
			[hlt flt flt sdw sdw sdw sdw sdw sdw sdw]
			[hlt flt flt sdw sdw sdw sdw sdw sdw sdw]
			[hlt flt flt sdw sdw sdw sdw sdw sdw sdw]
			[hlt flt flt sdw sdw sdw sdw sdw sdw sdw]
			[hlt flt flt sdw sdw sdw sdw sdw sdw sdw]
			[hlt flt flt sdw sdw sdw sdw sdw sdw sdw]
			[hlt flt flt sdw sdw sdw sdw sdw sdw sdw]
		])
		
		(corner-top-right (make-sized-image 10 10))
		(corner-top-right-mask [
			[hlt hlt hlt hlt hlt hlt hlt hlt hlt sdw]
			[flt flt flt flt flt flt flt flt flt sdw]
			[flt flt flt flt flt flt flt flt flt sdw]
			[sdw sdw sdw sdw sdw sdw hlt flt flt sdw]
			[sdw sdw sdw sdw sdw sdw hlt flt flt sdw]
			[sdw sdw sdw sdw sdw sdw hlt flt flt sdw]
			[sdw sdw sdw sdw sdw sdw hlt flt flt sdw]
			[sdw sdw sdw sdw sdw sdw hlt flt flt sdw]
			[sdw sdw sdw sdw sdw sdw hlt flt flt sdw]
			[sdw sdw sdw sdw sdw sdw hlt flt flt sdw]			
		])

		(corner-bottom-left (make-sized-image 10 10))
		(corner-bottom-left-mask [
			[hlt flt flt sdw sdw sdw sdw sdw sdw sdw]
			[hlt flt flt sdw sdw sdw sdw sdw sdw sdw]
			[hlt flt flt sdw sdw sdw sdw sdw sdw sdw]
			[hlt flt flt sdw sdw sdw sdw sdw sdw sdw]
			[hlt flt flt sdw sdw sdw sdw sdw sdw sdw]
			[hlt flt flt sdw sdw sdw sdw sdw sdw sdw]
			[hlt flt flt sdw sdw sdw sdw sdw sdw sdw]
			[hlt flt flt flt flt flt flt flt flt flt]
			[hlt flt flt flt flt flt flt flt flt flt]
			[hlt sdw sdw sdw sdw sdw sdw sdw sdw sdw]
		])
		
		(corner-bottom-right (make-sized-image 10 10))
		(corner-bottom-right-mask [
			[sdw sdw sdw sdw sdw sdw sdw flt flt sdw]
			[sdw sdw sdw sdw sdw sdw sdw flt flt sdw]
			[sdw sdw sdw sdw sdw sdw sdw flt flt sdw]
			[sdw sdw sdw sdw sdw sdw sdw flt flt sdw]
			[sdw sdw sdw sdw sdw sdw sdw flt flt sdw]
			[sdw sdw sdw sdw sdw sdw sdw flt flt sdw]
			[sdw sdw sdw sdw sdw sdw sdw flt flt sdw]
			[flt flt flt flt flt flt flt flt flt sdw]
			[flt flt flt flt flt flt flt flt flt sdw]
			[sdw sdw sdw sdw sdw sdw sdw sdw sdw sdw]
		])
		
		(corner-bottom-right-shaped (make-sized-image 4 4))
		(corner-bottom-right-shaped-mask [
			[hlt flt flt sdw]
			[flt flt flt sdw]
			[flt flt flt sdw]
			[sdw sdw sdw sdw]
		])

		(corner-bottom-left-shaped (make-sized-image 4 4))
		(corner-bottom-left-shaped-mask [
			[hlt flt flt hlt]
			[hlt flt flt flt]
			[hlt flt flt flt]
			[hlt sdw sdw sdw]
		])
		
		(default-title (make-sized-image (screen-width) 1))
		(focused-title (make-sized-image (screen-width) 1))
		
		(build-theme (lambda ()
			(let*
				(
					(image-generator (lambda (mask)
						(lambda (x y)
							(color-rgb-8 (symbol-value
								(aref (aref mask y) x)
							))
						)
					))
					
					(generate-image (lambda (image-mask)
						(image-fill
							(image-generator (cdr image-mask))
							(car image-mask)
						)
					))
				)
				
				;; draw gradients
				
				(draw-horizontal-gradient
					default-title
					Clean+:DefaultTitleLeft
					Clean+:DefaultTitleRight
				)
				
				(draw-horizontal-gradient
					focused-title
					Clean+:FocusedTitleLeft
					Clean+:FocusedTitleRight
				)
				
				;; load default icon
				
				(if (eql 0 (length Clean+:DefaultIcon))
					(setq user-icon ())
					(setq user-icon (make-image Clean+:DefaultIcon))
				)
				
				;; set colors
				
				(setq hlt Clean+:DecorationHighlight)
				(setq flt Clean+:DecorationFlat)
				(setq sdw Clean+:DecorationShadow)
				(setq ebt Clean+:EnabledButton)
				(setq dbt Clean+:DisabledButton)
				(setq ftr Clean+:FocusedTitleRight)
				
				;; generate decorations
				
				(mapc
					generate-image
					`(
						(,corner-top-left . ,corner-top-left-mask)
						(,corner-top-right . ,corner-top-right-mask)
						(,corner-bottom-left . ,corner-bottom-left-mask)
						(,corner-bottom-right . ,corner-bottom-right-mask)
						(,side-top . ,side-top-mask)
						(,side-bottom . ,side-bottom-mask)
						(,side-left . ,side-left-mask)
						(,side-right . ,side-right-mask)
						(,side-subtitle . ,side-subtitle-mask)
						(,corner-top-sides . ,corner-top-sides-mask)
						(,close-image-default . ,close-image-default-mask)
						(,close-image-clicked . ,close-image-clicked-mask)
						(,close-image-disabled . ,close-image-disabled-mask)
						(,maximize-image-default . ,maximize-image-default-mask)
						(,maximize-image-clicked . ,maximize-image-clicked-mask)
						(,maximize-image-disabled . ,maximize-image-disabled-mask)
						(,minimize-image-default . ,minimize-image-default-mask)
						(,minimize-image-clicked . ,minimize-image-clicked-mask)
						(,minimize-image-disabled . ,minimize-image-disabled-mask)
						(,corner-bottom-left-shaped . ,corner-bottom-left-shaped-mask)
						(,corner-bottom-right-shaped . ,corner-bottom-right-shaped-mask)
					)
				)
			)
		))
		
		(title-text-color (lambda (X)
			`(,Clean+:DefaultTitleText ,Clean+:FocusedTitleText)
		))

		(title-font (lambda (X)
			Clean+:TitleFont
		))
		
		(hide-icon (lambda (X)
			(not Clean+:ShowIcon)
		))
		
		(text-justify (lambda(X)
			(if Clean+:ShowIcon 24 3)
		))

		;; title-parts
		(title-parts `(
			(
				(class . title)
				(background . (,default-title	,focused-title))
				(foreground . ,title-text-color)
				(font . ,title-font)
				(text . ,window-name)
				(x-justify . ,text-justify)
				(y-justify . center)
				(left-edge . 1)
				(right-edge . 1)
				(top-edge . -20)
				(height . 17)
			)
			(
				(class . menu-button)
				(background . ,menu-image)
				(x-justify . center)
				(y-justify . center)
				(top-edge . -20)
				(left-edge . 3)
				(width . 16)
				(height . 16)
				(hidden . ,hide-icon)
			)
		))
				
		;; common-parts
		(common-parts `(
			(
				(class . left-border)
				(top-edge . -14)
				(height . 14)
				(background . ,corner-top-sides)
				(left-edge . -3)
			)
			(
				(class . top-left-corner)
				(background . ,corner-top-left)
				(left-edge . -3)
				(top-edge . -24)
			)
			(
				(class . top-border)
				(background . ,side-top)
				(left-edge . 7)
				(right-edge . 7)
				(top-edge . -24)
			)
			(
				(class . top-right-corner)
				(background . ,corner-top-right)
				(right-edge . -3)
				(top-edge . -24)
			)
			(
				(class . right-border)
				(top-edge . -14)
				(height . 14)
				(background . ,corner-top-sides)
				(right-edge . -3)
			)
			(
				(background . ,side-subtitle)
				(left-edge  . 0)
				(right-edge . 0)
				(top-edge   . -3)
			)
			(
				(class . right-border)
				(top-edge . 0)
				(bottom-edge . 7)
				(background . ,side-right)
				(right-edge . -3)
				(below-client . t)
			)
			(
				(class . bottom-right-corner)
				(background . ,corner-bottom-right)
				(right-edge . -3)
				(bottom-edge . -3)
				(below-client . t)
			)
			(
				(class . bottom-border)
				(background . ,side-bottom)
				(left-edge . 7)
				(right-edge . 7)
				(bottom-edge . -3)
				(below-client . t)
			)
			(
				(class . bottom-left-corner)
				(background . ,corner-bottom-left)
				(left-edge . -3)
				(bottom-edge . -3)
				(below-client . t)
			)
			(

				(class . left-border)
				(background . ,side-left)
				(left-edge . -3)
				(top-edge . 0)
				(bottom-edge . 7)
				(below-client . t)
			)
		))
		
		(shaped-parts `(
			(
				(class . title)
				(background . ,corner-top-left)
				(left-edge . -3)
				(top-edge . -24)
			)
			(
				(class . title)
				(background . ,side-top)
				(left-edge . 7)
				(right-edge . 7)
				(top-edge . -24)
			)
			(
				(class . title)
				(background . ,corner-top-right)
				(right-edge . -3)
				(top-edge . -24)
			)
			(
				(class . title)
				(top-edge . -14)
				(height . 11)
				(background . ,corner-top-sides)
				(right-edge . -3)
			)
			(
				(class . title)
				(background . ,corner-bottom-right-shaped)
				(right-edge . -3)
				(top-edge . -3)
			)
			(
				(class . title)
				(background . ,side-top)
				(left-edge . 1)
				(right-edge . 1)
				(top-edge . -3)
			)
			(
				(class . title)
				(background . ,corner-bottom-left-shaped)
				(left-edge . -3)
				(top-edge . -3)
			)
			(
				(class . title)
				(top-edge . -14)
				(height . 11)
				(background . ,corner-top-sides)
				(left-edge . -3)
			)
		))

		(close-button `(
			(
				(background . ,close-image-disabled)
				(right-edge . 3)
				(top-edge . -18)
			)
			(
				(class . close-button)
				(background . ,close-image)
				(right-edge . 3)
				(top-edge . -18)
				(removable . t)
			)
		))
		
		(button-parts `(
			,@close-button
			(
				(background . ,maximize-image-disabled)
				(right-edge . 16)
				(top-edge . -18)
			)
			(
				(class . maximize-button)
				(background . ,maximize-image)
				(right-edge . 16)
				(top-edge . -18)
				(removable . t)
			)
			(
				(background . ,minimize-image-disabled)
				(right-edge . 29)
				(top-edge . -18)
			)
			(
				(class . iconify-button)
				(background . ,minimize-image)
				(right-edge . 29)
				(top-edge . -18)
				(removable . t)
			)
		))
              
		(default-frame `(,@common-parts ,@title-parts ,@button-parts))
		(transient-frame `(,@common-parts ,@title-parts ,@close-button))
		(shaped-frame `(,@shaped-parts ,@title-parts ,@button-parts))
		(shaped-transient-frame `(,@shaped-parts ,@title-parts ,@close-button))
		
		(rebuild-theme (lambda ()
			(build-theme)
			(reframe-windows-with-style 'Clean+)
		))
		      
	)

	(build-theme)
	
	(add-frame-style 'Clean+
		(lambda (w type)
			(case type
				((default) default-frame)
				((transient) transient-frame)
				((shaped) shaped-frame)
				((shaped-transient) shaped-transient-frame)
			)
		)
        
	)
	
	(custom-set-property 'Clean+:ShowIcon ':after-set rebuild-theme)
	
	(custom-set-property 'Clean+:TitleFont ':after-set rebuild-theme)
	
	(custom-set-property 'Clean+:DefaultTitleText ':after-set rebuild-theme)
	(custom-set-property 'Clean+:DefaultTitleLeft ':after-set rebuild-theme)
	(custom-set-property 'Clean+:DefaultTitleRight ':after-set rebuild-theme)
	
	(custom-set-property 'Clean+:FocusedTitleText ':after-set rebuild-theme)
	(custom-set-property 'Clean+:FocusedTitleLeft ':after-set rebuild-theme)
	(custom-set-property 'Clean+:FocusedTitleRight ':after-set rebuild-theme)
	
	(custom-set-property 'Clean+:DecorationHighlight ':after-set rebuild-theme)
	(custom-set-property 'Clean+:DecorationFlat ':after-set rebuild-theme)
	(custom-set-property 'Clean+:DecorationShadow ':after-set rebuild-theme)

	(custom-set-property 'Clean+:EnabledButton ':after-set rebuild-theme)
	(custom-set-property 'Clean+:DisabledButton ':after-set rebuild-theme)
	
	(custom-set-property 'Clean+:DefaultIcon ':after-set rebuild-theme)
)
